unit Unit1;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, Registry, Menus,
   HidClass;

type
   // the simple Form we show
   TDevEventForm = class(TForm)
      ListBox1    : TListBox;
      MainMenu    : TMainMenu;
      QuitMenuItem: TMenuItem;
      FileMenu    : TMenuItem;
      procedure DeviceChanges    (Sender: TObject);
      function  Enumeration      (HidDev: THidDevice; Index: Integer): Boolean;
      procedure FormCreate       (Sender: TObject);
      procedure QuitMenuItemClick(Sender: TObject);
    private
      { Private declarations }
    public
      { Public declarations }
       HidController: THidDeviceController;
   end;

var
   DevEventForm: TDevEventForm;

implementation

{$R *.DFM}

procedure TDevEventForm.DeviceChanges(Sender: TObject);
begin
   ListBox1.Clear;
   HidController.Enumerate;
end;

function TDevEventForm.Enumeration(HidDev: THidDevice; Index: Integer): Boolean;
var
   p: String;
begin
   with HidDev do
   begin
      p := VendorName;
      if p = '' then
         p := RegDescr;
      ListBox1.Items.Add(Format('%x %x %s: %s',[Attributes.VendorID,Attributes.ProductID,p,ProductName]));
   end;
   Result := True;
end;

procedure TDevEventForm.FormCreate(Sender: TObject);
begin
   // the HidController handles all HidDevices
   // later this will be replaced by a placeable component
   HidController := THidDeviceController.Create(Self);
   with HidController do
   begin
      OnDeviceChange := DeviceChanges;
      OnEnumerate    := Enumeration;
      Enumerate;
   end;
end;

procedure TDevEventForm.QuitMenuItemClick(Sender: TObject);
begin
   Close;
end;

end.
