// HidToken.pas contains the consts from HidToken.h
// all the comments are original
//
// Public Definitions of HID USAGES.

unit HidToken;

interface

const
  cHIDPITEM_LONG           = $FE;
  cHIDPITEM_LENGTH_DATA    = $03;

  // Main Items
  // Only main items with one byte data (bSize = 1) are supported.
  cHIDPMain_INPUT_1         = $81;
  cHIDPMain_INPUT_2         = $82;
  cHIDPMain_OUTPUT_1        = $91;
  cHIDPMain_OUTPUT_2        = $92;
  cHIDPMain_FEATURE_1       = $B1;
  cHIDPMain_FEATURE_2       = $B2;
  cHIDPMain_COLLECTION      = $A1;
  cHIDPMain_ENDCOLLECTION   = $C0;
  cHIDPMain_COLLECTION_LINK = $00;
  cHIDPMain_COLLECTION_APP  = $01;

  // Global Items
  cHIDPGlobal_USAGE_PAGE_1   = $05;  // UsagePage of 1 byte
  cHIDPGlobal_USAGE_PAGE_2   = $06;  // UsagePage of 2 bytes
  cHIDPGlobal_USAGE_PAGE_4   = $07;  // UsagePage of 4 bytes
  cHIDPGlobal_LOG_MIN_1      = $15;  // minimum value of size 1 byte.
  cHIDPGlobal_LOG_MIN_2      = $16;  // minimum value of size 2 bytes.
  cHIDPGlobal_LOG_MIN_4      = $17;  // minimum value of size 4 bytes.
  cHIDPGlobal_LOG_MAX_1      = $25;  // maximum of size 1 byte.
  cHIDPGlobal_LOG_MAX_2      = $26;  // maximum of size 2 bytes.
  cHIDPGlobal_LOG_MAX_4      = $27;  // maximum of size 4 bytes.

  cHIDPGlobal_PHY_MIN_1      = $35;  // minimum value of size 1 byte.
  cHIDPGlobal_PHY_MIN_2      = $36;  // minimum value of size 2 bytes.
  cHIDPGlobal_PHY_MIN_4      = $37;  // minimum value of size 4 bytes.
  cHIDPGlobal_PHY_MAX_1      = $45;  // maximum of size 1 byte.
  cHIDPGlobal_PHY_MAX_2      = $46;  // maximum of size 2 bytes.
  cHIDPGlobal_PHY_MAX_4      = $47;  // maximum of size 4 bytes.

  cHIDPGlobal_UNIT_EXP_1     = $55;  // Exponent of size 1 byte.
  cHIDPGlobal_UNIT_EXP_2     = $56;  // Exponent of size 2 bytes.
  cHIDPGlobal_UNIT_EXP_4     = $57;  // Exponent of size 4 bytes.
  cHIDPGlobal_UNIT_1         = $65;  // UNIT of size 1 byte.
  cHIDPGlobal_UNIT_2         = $66;  // UNIT of size 2 bytes.
  cHIDPGlobal_UNIT_4         = $67;  // UNIT of size 4 bytes.

  cHIDPGlobal_REPORT_SIZE    = $75;  // Report size in bits
  cHIDPGlobal_REPORT_ID      = $85;  // ID only size 1 byte supported
  cHIDPGlobal_REPORT_COUNT_1 = $95;  // Number of data fields 1 byte
  cHIDPGlobal_REPORT_COUNT_2 = $96;  // Number of data fields 2 bytes
  cHIDPGlobal_PUSH           = $A4;  // The dreaded PUSH command
  cHIDPGlobal_POP            = $B4;  // And the dreaded POP command

  // Local Items
  cHIDPLocal_USAGE_1         = $09;
  cHIDPLocal_USAGE_2         = $0A;
  cHIDPLocal_USAGE_4         = $0B;
  cHIDPLocal_USAGE_MIN_1     = $19;
  cHIDPLocal_USAGE_MIN_2     = $1A;
  cHIDPLocal_USAGE_MIN_4     = $1B;
  cHIDPLocal_USAGE_MAX_1     = $29;
  cHIDPLocal_USAGE_MAX_2     = $2A;
  cHIDPLocal_USAGE_MAX_4     = $2B;
  cHIDPLocal_DESIG_INDEX     = $39;  // Designators of byte size supported
  cHIDPLocal_DESIG_MIN       = $49;
  cHIDPLocal_DESIG_MAX       = $59;
  cHIDPLocal_STRING_INDEX    = $79;  // String indices of size byte supported
  cHIDPLocal_STRING_MIN      = $89;
  cHIDPLocal_STRING_MAX      = $99;
  cHIDPLocal_DELIMITER       = $A9;

implementation

end.
