struct message {
  unsigned char boardID;
    /* ID of the board you're adressing, 255 means broadcast to all boards. */

  unsigned char commandID;
    /* The command you're trying to execute:
     *  0 	= Turn everyting off directly, other parameters are ignored.
     *  1	= Switch primairy output on.
     *  2	= Switch secundairy output on.
     *  254	= Respond with boardID and software revision.
     *  255	= Send an ID signal, makes control led blink for 10 seconds.
     *  256	= Change board ID to number defined in Bus ID
     *			Channel ID must be 0xCC for confirmation of action.
     */

  unsigned char commandTime;
    /* Defines the time to switch an output on
     *	0        = Continuously (stop with command 0)
     *	1 to 255 = 0.01 to 2.55 seconds (0.01s increments)
     */


  unsigned char busID;
    /* Gives the busID of the channel to adress, normally this is 1 to 4
     *	as written on the board.
     *
     *	Note: This value also indicates the new board number when
     *		the board number is changed using command 256. 
     */

  unsigned char channelID;
    /* defines the actual channel to control, normally this is 0 to 63
     *	which corresponds with the oupput numbering of the decoder boards.
     *
     *	Note: When changing board numbers, this value must be 0xCC to
     *		confirm the command is really to change board numbers. 
     */

  unsigned char unused1, unused2;
    /* Unused bytes for possible future expansions */

  unsigned char checksum;
    /* Adds a checksum to the message, this is calculated by XOR on all
     * other bytes:
     * checksum = boardID ^ commandID ^ commandtime ^ busID ^ channelID;
     */
}
